init:
	LDA #$00
	STA $7F8331
	RTL
	
main:
	JSR ssd
	RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;do not insert this as blocks. This is a non-block ASM code for the
;screen scrolling doors. put this in gamemode_code.asm in "gamemode_14:"
;or level_code.asm (if multiple levels, use "JSR levelxxx" to a level that
;have this code to recycle code and save space).
;
;if you wanted to edit the speed, go to the table on the bottom of
;this code, and change the value.
;
;TIP: To have "equal" positive (#$01-#$7F) and negative (#$80-#$FF) speed,
;use this forumla (all in hex):
;
;N=100-P
;
;N = negative (left and up speed)
;P = positive (right and down speed)
;
;tip2:
;you can instantly copy this code by pressing "ctrl+A" to select all then
;"ctrl+C" to copy
;
;freeram address------------------------------------------------------------
;
!freeram_door_dir = $7F8331		;>change this if used by other stuff
;					;besides the screen scrolling doors.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;code begins;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ssd:
	LDA !freeram_door_dir		;\if door_mode mode is 00 (not launching)
	BEQ returndoor			;/then return_door_mode
	TAY				;\set x and Y speed according to direction
	LDA x_speed_table,y		;|
	STA $7B				;|
	LDA y_speed_table,y		;|
	STA $7D				;/
	LDA !freeram_door_dir		;\if going left or right
	CMP #$02			;|set facing direction
	BEQ face_right			;|
	CMP #$04			;|
	BEQ face_left			;/
	BRA skip_face_dir		;>or don't set it at all if vertical
face_right:				;\set facing direction
	LDA #$01			;|
	STA $76				;|
	BRA skip_face_dir		;|
face_left:				;|
	STZ $76				;/
skip_face_dir:
	STZ $15			;\
	STZ $16			;|lock controls while door mode
	STZ $17			;|
	STZ $18			;/
	STZ $149A		;>remove kick pose if player enters door immediately after kicking.
	LDA #$FF		;\hide player
	STA $78			;/
	LDA #$0B		;\freeze player (so $9D works)
	STA $71			;/
	STA $9D			;>lock animations
	STA $1404		;>allow screen to scroll up.
	LDA #$01		;>load nonzero
	STA $1497		;>set Flashing invulnerability timer
	STA $13F9		;>go behind layer
	STA $73			;>maintain ducking flag
returndoor:
	RTS			;>if you have a following code from here
				;then move the table that was below here
				;to the very bottom and have the other codes
				;between here and the table below.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;x and y speed table. Make sure that the table is right after (or below) the
;codes that points to it (so this table is after "LDA x_speed_table,y being
;used), or the game will crash.
;
;Each seprate number is a value for mario x and y speed, the order in the table
;corrosponds the value order present within the selected ram. For example: the
;first number in the table means that the ram is #$00, the 2nd number is when
;the ram address = #$01 and so on.
;(order from left to right)
;1st number = not used
;2nd number = up
;3rd number = right
;4th number = down
;5th number = left
;
;If you change this, you should also change how many pixels down
;from the center of the door that mario will exit upwards from
;door_down.asm in the blocks' definition.
;
x_speed_table:
	db $00,$00,$2F,$00,$D1
	RTS
y_speed_table:
	db $00,$D1,$00,$2F,$00